﻿/*
 * Created by SharpDevelop.
 * User: Administrator
 * Date: 6/17/2009
 * Time: 12:30 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using System.Threading;

using MapSharpLib;

namespace PrimeSearchExe
{
	class Program
	{
		public static void Main(string[] args)
		{
			Console.WriteLine("Hello PrimeSearch!");
			
			//You should be running a NodeApp at the same time, otherwise, nothing'll happen.
			MRNetworkNode mrnn = new MRNetworkNode(1901);
			MRNetworkNode mrnn2 = new MRNetworkNode(1902);
			
			
			#region nodes
			//HACK: Hardcoded stuff
			int serverCount = 2;
			int managerPort = 1900;
			int firstServerPort = 1901;
			int maxValPrime = 7000;
			
			MRManager mrm = new MRManager(managerPort);
			List<string> Nodes = new List<string>();
			for(int i=0; i<serverCount;i++)
			{
				Nodes.Add("127.0.0.1:" + (firstServerPort+i).ToString());
			}
			#endregion			
			mrm.NodesList = Nodes;
			mrm.Do(PrimeSearch.PrimeSearchJob.FullJob(maxValPrime), 1000);
			
			//TODO: make it print only if the description's changed.
			while(!mrm.isDone())
			{
				IEnumerable<NodeDescription> nds = mrm.NodeStats;
				foreach(NodeDescription nd in nds)
					Console.WriteLine(nd);
				Thread.Sleep(300);
			}
			
			HashSet<int> finalresults = new HashSet<int>();
			foreach(Job j in mrm.CurrentResults)
			{
				finalresults.UnionWith(((wrapper<IEnumerable<int>>)(j.Results)).Value);
			}
			
			#region prove its correct
			if(PrimeSearch.Check.isCorrect(maxValPrime, finalresults))
				Console.WriteLine("Woot! it works!");
			else
				Console.WriteLine("Darn! it don't work!");
			#endregion
			
			Console.Write("Press any key to continue . . . ");
			Console.ReadKey(true);
			
			mrm.Stop();
			mrnn.Stop();
			mrnn2.Stop();
		}
	}
}